<template>
  <q-toolbar class="bg-primary text-white">
    <q-toolbar-title>Entrypoints</q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>
  <q-list bordered class="scroll_list">
    <q-item clickable v-ripple
            v-for="dts in dts_filtered"
            v-bind:id="dts.name"
            v-bind:key="dts.name"
            v-on:click="getdts"
            :class="item_classes(dts)">{{ dts.nice_name }}
    </q-item>
  </q-list>
</template>

<script>
import {api} from 'boot/axios';
import _ from 'lodash';

export default {
  name: "DtsList.vue",
  data() {
    return {
      dtslist: [{name: undefined}],
      current_dts: undefined,
      search_value: undefined
    }
  },
  created() {
    this.fetchData()
  },
  methods: {
    getdts: function (event) {
      this.current_dts = event.target.id
      this.$router.push({path: "/dts/" + this.current_dts})
    },
    fetchData: function () {
      api
        .get("/dts")
        .then(response => (this.dtslist = response.data))
    },
    item_classes: function (dts) {
      if (!_.isUndefined(dts.has_presentation)) {
        if (dts.has_presentation) {
          return "presentation"
        } else {
          return 'no_presentation'
        }
      } else {
        return ''
      }
    }
  },
  computed: {
    dts_filtered() {
      if (typeof (this.search_value) !== 'undefined' && this.search_value.length > 0) {
        return this.dtslist.filter(dts => dts.name.toLowerCase().includes(this.search_value.toLowerCase()))
      } else {
        return this.dtslist
      }
    }
  }
}
</script>

<style scoped lang="scss">
.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 190px);
}

.presentation {
  border-left: 10px solid $yellow;
  background-color: $yellow-1;
}

.no_presentation {
  border-left: 10px solid transparent;
}
</style>
